---
title: Media Source API
slug: Web/API/Media_Source_Extensions_API
tags:
  - API
  - Audio
  - Experimental
  - Landing
  - MSE
  - Media Source Extensions
  - Reference
  - Video
  - streaming
---
<p>{{DefaultAPISidebar("Media Source Extensions")}}{{ Draft}}</p>

<p class="summary">The <strong>Media Source API</strong>, formally known as <strong>Media Source Extensions</strong> (<strong>MSE</strong>), provides functionality enabling plugin-free web-based streaming media. Using MSE, media streams can be created via JavaScript, and played using {{htmlelement("audio")}} and {{htmlelement("video")}} elements.</p>

<h2 id="Media_Source_Extensions_concepts_and_usage">Media Source Extensions concepts and usage</h2>

<p>Playing video and audio has been available in web applications without plugins for a few years now, but the basic features offered have really only been useful for playing single whole tracks. We can't, for example, combine/split arraybuffers. Streaming media has up until recently been the domain of Flash, with technologies like Flash Media Server serving video streams using the RTMP protocol.</p>

<h3 id="The_MSE_standard">The MSE standard</h3>

<p>With Media Source Extensions (MSE), this is changing. MSE allows us to replace the usual single track <code>src</code> value fed to media elements with a reference to a <code>MediaSource</code> object, which is a container for information like the ready state of the media for being played, and references to multiple <code>SourceBuffer</code> objects that represent the different chunks of media that make up the entire stream. MSE gives us finer grained control over how much and how often content is fetched, and some control over memory usage details, such as when buffers are evicted. It lays the groundwork for adaptive bitrate streaming clients (such as those using DASH or HLS) to be built on its extensible API.</p>

<p>Creating assets that work with MSE in modern browsers is a laborious process, taking significant time, computing power, and energy. The usage of external utilities to massage the content into a suitable format is required. While browser support for the various media containers with MSE is spotty, usage of the H.264 video codec, AAC audio codec, and MP4 container format is a common baseline. MSE also provides an API for runtime detection of container and codec support.</p>

<p>If you do not require explicit control of video quality over time, the rate at which content is fetched, or the rate at which memory is evicted, then the {{htmlelement("video")}} and {{htmlelement("source")}} tags may well be a simple and adequate solution.</p>

<h3 id="DASH">DASH</h3>

<p>Dynamic Adaptive Streaming over HTTP (DASH) is a protocol for specifying how adaptive content should be fetched. It is effectively a layer built on top of MSE for building adaptive bitrate streaming clients. While there are other protocols available (such as HTTP Live Streaming (HLS)), DASH has the most platform support.</p>

<p>DASH moves lots of logic out of the network protocol and into the client side application logic, using the simpler HTTP protocol to fetch files.  Indeed, one can support DASH with a simple static file server, which is also great for CDNs.  This is in direct contrast with previous streaming solutions that required expensive licenses for proprietary non-standard client/server protocol implementations.</p>

<p>The two most common use cases for DASH involve watching content “on demand” or “live.”  On demand allows a developer to take their time transcoding the assets into multiple resolutions of various quality.</p>

<p>Live profile content can introduce latency due to its transcoding and broadcasting, so DASH is not suitable for real time communication like <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> is. It can however support significantly more client connections than WebRTC.</p>

<p>There are numerous available free and open source tools for transcoding content and preparing it for use with DASH, DASH file servers, and DASH client libraries written in JavaScript.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("MediaSource")}}</dt>
 <dd>Represents a media source to be played via an {{domxref("HTMLMediaElement")}} object.</dd>
 <dt>{{domxref("SourceBuffer")}}</dt>
 <dd>Represents a chunk of media to be passed into an {{domxref("HTMLMediaElement")}} via a <code>MediaSource</code> object.</dd>
 <dt>{{domxref("SourceBufferList")}}</dt>
 <dd>A simple container list for multiple <code>SourceBuffer</code> objects.</dd>
 <dt>{{domxref("VideoPlaybackQuality")}}</dt>
 <dd>Contains information about the quality of video being played by a {{htmlelement("video")}} element, such as number of dropped or corrupted frames. Returned by the {{domxref("HTMLVideoElement.getVideoPlaybackQuality()")}} method.</dd>
 <dt>{{domxref("TrackDefault")}}</dt>
 <dd>Provides a {{domxref("SourceBuffer")}} with kind, label, and language information for tracks that do not contain this information in the <a href="https://w3c.github.io/media-source/#init-segment">initialization segments</a> of a media chunk.</dd>
 <dt>{{domxref("TrackDefaultList")}}</dt>
 <dd>A simple container list for multiple <code>TrackDefault</code> objects.</dd>
</dl>

<h2 id="Extensions_to_other_interfaces">Extensions to other interfaces</h2>

<dl>
 <dt>{{domxref("URL.createObjectURL()")}}</dt>
 <dd>Creates an object URL pointing to a <code>MediaSource</code> object that can then be specified as the <code>src</code> value of an HTML media element to play a media stream.</dd>
 <dt>{{domxref("HTMLMediaElement.seekable")}}</dt>
 <dd>When a <code>MediaSource</code> object is played by an HTML media element, this property will return a {{domxref("TimeRanges")}} object that contains the time ranges that the user is able to seek to.</dd>
 <dt>{{domxref("HTMLVideoElement.getVideoPlaybackQuality()")}}</dt>
 <dd>Returns a {{domxref("VideoPlaybackQuality")}} object for the currently played video.</dd>
 <dt>{{domxref("AudioTrack.sourceBuffer")}}, {{domxref("VideoTrack.sourceBuffer")}}, {{domxref("TextTrack.sourceBuffer")}}</dt>
 <dd>Returns the {{domxref("SourceBuffer")}} that created the track in question.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<h3 id="MediaSource_interface">MediaSource interface</h3>

<div>

<p>{{Compat("api.MediaSource", 0)}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Source_Extensions_API/Transcoding_assets_for_MSE">Transcoding assets for Media Source Extensions</a></li>
 <li>Using MSE to create a basic streaming service (TBD)</li>
 <li>Using MPEG DASH to create a streaming application (TBD)</li>
 <li>The {{htmlelement("audio")}} and {{htmlelement("video")}} elements.</li>
 <li>{{domxref("HTMLMediaElement")}}, {{domxref("HTMLVideoElement")}}, {{domxref("HTMLAudioElement")}}.</li>
</ul>
